#include "main.h"
#include "stm32f1xx_hal.h"
#include <string.h>

extern void    FLASH_PageErase(uint32_t PageAddress);

// #define ERASE_OPTIONS

int
Program_Options( int id )
{
  int           i, status;
  uint32_t     *s, *d;

  s = ( uint32_t * ) & LocalOptions;
  d = ( uint32_t * ) ( &__EEPROM_segment_start__ + id * SO_SIZE );
  HAL_FLASH_Unlock(  );
  for( i = 0; i < SO_SIZE; i += 4 )
  {
    status =
	HAL_FLASH_Program( FLASH_TYPEPROGRAM_WORD, ( uint32_t ) d++, *s++ );
    if( status != HAL_OK )
      break;
  }
  HAL_FLASH_Lock(  );
  return status;
}


void
NV_Options( void )
{
  int           status, erase = false;
#ifndef ERASE_OPTIONS
  struct SavedOptions *sv =
      ( struct SavedOptions * ) &__EEPROM_segment_start__;

  while( sv <= ( struct SavedOptions * ) ( ( u32 ) & __EEPROM_segment_end__ -
      SO_SIZE ) && sv->id != 0xffff )
    sv = ( struct SavedOptions * ) ( ( u32 ) sv + SO_SIZE );
  // start with default options
  if( sv == ( struct SavedOptions * ) ( &__EEPROM_segment_start__ ) )
  {
    sv = &LocalOptions;
    sv->id = 0xffff;
    sv->volume_steps = VOLUME_STEPS;
    sv->volume_last = VOLUME_STEPS / 2;
    return;
  }
  // local options end of sector reached
  if( sv >= ( struct SavedOptions * )
      ( ( uint32_t ) & __EEPROM_segment_end__ - SO_SIZE ) )
    erase = true;
  // step back to last valid options
  sv = ( struct SavedOptions * ) ( ( uint32_t ) sv - SO_SIZE );
  memcpy( &LocalOptions, sv, sizeof( struct SavedOptions ) );
  sv = &LocalOptions;
  if( erase )
  {
#endif
    HAL_FLASH_Unlock(  );
    FLASH_PageErase((u32) &__EEPROM_segment_start__);
    status = FLASH_WaitForLastOperation( ( uint32_t ) FLASH_ERASE_TIMEOUT );
    CLEAR_BIT( FLASH->CR, FLASH_CR_PER );
    if( status != HAL_OK )
      return;
#ifndef ERASE_OPTIONS
    sv->id = 0;
    Program_Options( sv->id );
  }
#endif
}
