TIM_TypeDef  *const base_timer[4] = { TIM1, TIM2, TIM3, TIM4 };

u8            sf_timer[5];

void
HAL_GPIO_EXTI_Callback( uint16_t GPIO_Pin )
{
  Surface      *sf = &spi_tx_data.sf;
  int           bit = 31 - __builtin_clz( GPIO_Pin );
  int           i, j;

  if( sf_timer[bit] )		// timer was allocated for this pin
  {
    if( base_timer[sf_timer[bit] - 1]->CR1 & TIM_CR1_CEN )	// ignore and return if timer is still counting
      return;
  }
  for( i = 0; i < 4; i++ )
    if( !( base_timer[i]->CR1 & TIM_CR1_CEN ) )	// find first available stopped timer
      break;
  if( i == 4 )			// no free timers, ignore event
    return;
  for( j = 0; j < 5; j++ )
    if( sf_timer[j] == i + 1 )	// remove timer from the other pins
      sf_timer[j] = 0;
  sf_timer[bit] = i + 1;
  base_timer[i]->CR1 |= TIM_CR1_CEN;	// start a one-pulse count
  // ...
}
